searchNodes=[{"doc":"A concurrent feature testing library. Configuration Wallaby supports the following options: :otp_app - The name of your OTP application. This is used to check out your Ecto repos into the SQL Sandbox. :screenshot_dir - The directory to store screenshots. :screenshot_on_failure - if Wallaby should take screenshots on test failures (defaults to false ). :max_wait_time - The amount of time that Wallaby should wait to find an element on the page. (defaults to 3_000 ) :js_errors - if Wallaby should re-throw JavaScript errors in elixir (defaults to true). :js_logger - IO device where JavaScript console logs are written to. Defaults to :stdio. This option can also be set to a file or any other io device. You can disable JavaScript console logging by setting this to nil .","ref":"Wallaby.html","title":"Wallaby","type":"module"},{"doc":"","ref":"Wallaby.html#driver/0","title":"Wallaby.driver/0","type":"function"},{"doc":"Ends a browser session.","ref":"Wallaby.html#end_session/1","title":"Wallaby.end_session/1","type":"function"},{"doc":"Starts a browser session. Multiple sessions Each session runs in its own browser so that each test runs in isolation. Because of this isolation multiple sessions can be created for a test: @message_field Query . text_field ( &quot;Share Message&quot; ) @share_button Query . button ( &quot;Share&quot; ) @message_list Query . css ( &quot;.messages&quot; ) test &quot;That multiple sessions work&quot; do { :ok , user1 } = Wallaby . start_session user1 |&gt; visit ( &quot;/page.html&quot; ) |&gt; fill_in ( @message_field , with : &quot;Hello there!&quot; ) |&gt; click ( @share_button ) { :ok , user2 } = Wallaby . start_session user2 |&gt; visit ( &quot;/page.html&quot; ) |&gt; fill_in ( @message_field , with : &quot;Hello yourself&quot; ) |&gt; click ( @share_button ) assert user1 |&gt; find ( @message_list ) |&gt; List . last |&gt; text == &quot;Hello yourself&quot; assert user2 |&gt; find ( @message_list ) |&gt; List . first |&gt; text == &quot;Hello there&quot; end","ref":"Wallaby.html#start_session/1","title":"Wallaby.start_session/1","type":"function"},{"doc":"","ref":"Wallaby.html#t:reason/0","title":"Wallaby.reason/0","type":"type"},{"doc":"","ref":"Wallaby.html#t:start_session_opts/0","title":"Wallaby.start_session_opts/0","type":"type"},{"doc":"The Browser module is the entrypoint for interacting with a real browser. By default, action only work with elements that are visible to a real user. Actions Actions are used to interact with form elements. All actions work with the query interface: &lt;label for=&quot;first_name&quot;&gt; First Name &lt;/label&gt; &lt;input id=&quot;user_first_name&quot; type=&quot;text&quot; name=&quot;first_name&quot;&gt; fill_in ( page , Query . text_field ( &quot;First Name&quot; ) , with : &quot;Grace&quot; ) fill_in ( page , Query . text_field ( &quot;first_name&quot; ) , with : &quot;Grace&quot; ) fill_in ( page , Query . text_field ( &quot;user_first_name&quot; ) , with : &quot;Grace&quot; ) These queries work with any of the available actions. fill_in ( page , Query . text_field ( &quot;First Name&quot; ) , with : &quot;Chris&quot; ) clear ( page , Query . text_field ( &quot;user_email&quot; ) ) click ( page , Query . radio_button ( &quot;Radio Button 1&quot; ) ) click ( page , Query . checkbox ( &quot;Checkbox&quot; ) ) click ( page , Query . checkbox ( &quot;Checkbox&quot; ) ) click ( page , Query . option ( &quot;Option 1&quot; ) ) click ( page , Query . button ( &quot;Some Button&quot; ) ) attach_file ( page , Query . file_field ( &quot;Avatar&quot; ) , path : &quot;test/fixtures/avatar.jpg&quot; ) Actions return their parent element so that they can be chained together: page |&gt; find ( Query . css ( &quot;.signup-form&quot; ) , fn ( form ) -&gt; form |&gt; fill_in ( Query . text_field ( &quot;Name&quot; ) , with : &quot;Grace Hopper&quot; ) |&gt; fill_in ( Query . text_field ( &quot;Email&quot; ) , with : &quot;grace@hopper.com&quot; ) |&gt; click ( Query . button ( &quot;Submit&quot; ) ) end ) Scoping Finders provide scoping like so: session |&gt; visit ( &quot;/page.html&quot; ) |&gt; find ( Query . css ( &quot;.users&quot; ) ) |&gt; find ( Query . css ( &quot;.user&quot; , count : 3 ) ) |&gt; List . first |&gt; find ( Query . css ( &quot;.user-name&quot; ) ) If a callback is passed to find then the scoping will only apply to the callback and the parent will be passed to the next action in the chain: page |&gt; find ( Query . css ( &quot;.todo-form&quot; ) , fn ( form ) -&gt; form |&gt; fill_in ( Query . text_field ( &quot;What needs doing?&quot; ) , with : &quot;Write Wallaby Documentation&quot; ) |&gt; click ( Query . button ( &quot;Save&quot; ) ) end ) |&gt; find ( Query . css ( &quot;.success-notification&quot; ) , fn ( notification ) -&gt; assert notification |&gt; has_text? ( &quot;Todo created successfully!&quot; ) end ) This allows you to create a test that is logically grouped together in a single pipeline. It also means that its easy to create re-usable helper functions without having to worry about chaining. You could re-write the above example like this: def create_todo ( page , todo ) do find ( Query . css ( &quot;.todo-form&quot; ) , &amp; fill_in_and_save_todo ( &amp;1 , todo ) ) end def fill_in_and_save_todo ( form , todo ) do form |&gt; fill_in ( Query . text_field ( &quot;What needs doing?&quot; ) , with : todo ) |&gt; click ( Query . button ( &quot;Save&quot; ) ) end def todo_was_created? ( page ) do find Query . css ( page , &quot;.success-notification&quot; ) , fn ( notification ) -&gt; assert notification |&gt; has_text? ( &quot;Todo created successfully!&quot; ) end end assert page |&gt; create_todo ( &quot;Write Wallaby Documentation&quot; ) |&gt; todo_was_created?","ref":"Wallaby.Browser.html","title":"Wallaby.Browser","type":"module"},{"doc":"Accepts one alert dialog, which must be triggered within the specified fun . Returns the message that was presented to the user. For example: message = accept_alert session , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger alert&quot; ) ) end","ref":"Wallaby.Browser.html#accept_alert/2","title":"Wallaby.Browser.accept_alert/2","type":"function"},{"doc":"Accepts one confirmation dialog, which must be triggered within the specified fun . Returns the message that was presented to the user. For example: message = accept_confirm session , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger confirm&quot; ) ) end","ref":"Wallaby.Browser.html#accept_confirm/2","title":"Wallaby.Browser.accept_confirm/2","type":"function"},{"doc":"Accepts one prompt, which must be triggered within the specified fun . The [with: value] option allows to simulate user input for the prompt. If no value is provided, the default value that was passed to window.prompt will be used instead. Returns the message that was presented to the user. For example: message = accept_prompt session , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger prompt&quot; ) ) end Example providing user input: message = accept_prompt session , [ with : &quot;User input&quot; ] , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger prompt&quot; ) ) end","ref":"Wallaby.Browser.html#accept_prompt/2","title":"Wallaby.Browser.accept_prompt/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#accept_prompt/3","title":"Wallaby.Browser.accept_prompt/3","type":"function"},{"doc":"Finds all of the DOM elements that match the CSS selector. If no elements are found then an empty list is immediately returned. This is equivalent to calling find(session, css(&quot;element&quot;, count: nil, minimum: 0)) .","ref":"Wallaby.Browser.html#all/2","title":"Wallaby.Browser.all/2","type":"function"},{"doc":"Checks if query is present within parent and raises if not found. Returns the given parent if the assertion is correct so that it is easily pipeable. Examples session |&gt; visit ( &quot;/&quot; ) |&gt; assert_has ( Query . css ( &quot;.login-button&quot; ) )","ref":"Wallaby.Browser.html#assert_has/2","title":"Wallaby.Browser.assert_has/2","type":"macro"},{"doc":"","ref":"Wallaby.Browser.html#assert_text/2","title":"Wallaby.Browser.assert_text/2","type":"function"},{"doc":"Matches the Element's content with the provided text and raises if not found. Returns the given parent if the assertion is correct so that it is easily pipeable. Examples session |&gt; visit ( &quot;/&quot; ) |&gt; assert_text ( &quot;Login&quot; ) Example providing query: session |&gt; visit ( &quot;/&quot; ) |&gt; assert_text ( Query . css ( &quot;.login-button&quot; ) , &quot;Login&quot; )","ref":"Wallaby.Browser.html#assert_text/3","title":"Wallaby.Browser.assert_text/3","type":"function"},{"doc":"Attaches a file to a file input. Input elements are looked up by id, label text, or name. When dealing with Selenium server (especially a remote instance), the file must be uploaded to Selenium via send_keys recognizing a local file, else attaching a file fails.","ref":"Wallaby.Browser.html#attach_file/3","title":"Wallaby.Browser.attach_file/3","type":"function"},{"doc":"Gets the value of the elements attribute.","ref":"Wallaby.Browser.html#attr/3","title":"Wallaby.Browser.attr/3","type":"function"},{"doc":"Clicks and holds the given mouse button at the current mouse coordinates.","ref":"Wallaby.Browser.html#button_down/2","title":"Wallaby.Browser.button_down/2","type":"function"},{"doc":"Releases given previously held mouse button.","ref":"Wallaby.Browser.html#button_up/2","title":"Wallaby.Browser.button_up/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#clear/2","title":"Wallaby.Browser.clear/2","type":"function"},{"doc":"Clicks the mouse on the element returned by the query or at the current mouse cursor position.","ref":"Wallaby.Browser.html#click/2","title":"Wallaby.Browser.click/2","type":"function"},{"doc":"Closes the current window. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;closing a window focuses the previously focused window&quot; , %{ session : session } do original_handle = session |&gt; visit ( &quot;/home&quot; ) |&gt; window_handle ( ) new_handle = session # click a link that takes you to a new tab |&gt; click ( Query . link ( &quot;External Page&quot; ) ) |&gt; close_window ( ) |&gt; window_handle ( ) assert original_handle == new_handle end","ref":"Wallaby.Browser.html#close_window/1","title":"Wallaby.Browser.close_window/1","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#cookies/1","title":"Wallaby.Browser.cookies/1","type":"function"},{"doc":"Gets the current path of the session","ref":"Wallaby.Browser.html#current_path/1","title":"Wallaby.Browser.current_path/1","type":"function"},{"doc":"Gets the current url of the session","ref":"Wallaby.Browser.html#current_url/1","title":"Wallaby.Browser.current_url/1","type":"function"},{"doc":"Dismisses one confirmation dialog, which must be triggered within the specified fun . Returns the message that was presented to the user. For example: message = dismiss_confirm session , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger confirm&quot; ) ) end","ref":"Wallaby.Browser.html#dismiss_confirm/2","title":"Wallaby.Browser.dismiss_confirm/2","type":"function"},{"doc":"Dismisses one prompt, which must be triggered within the specified fun . Returns the message that was presented to the user. For example: message = dismiss_prompt session , fn ( s ) -&gt; click ( s , Query . link ( &quot;Trigger prompt&quot; ) ) end","ref":"Wallaby.Browser.html#dismiss_prompt/2","title":"Wallaby.Browser.dismiss_prompt/2","type":"function"},{"doc":"Double-clicks left mouse button at the current mouse coordinates.","ref":"Wallaby.Browser.html#double_click/1","title":"Wallaby.Browser.double_click/1","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#execute_query/2","title":"Wallaby.Browser.execute_query/2","type":"function"},{"doc":"Executes JavaScript synchronously, taking as arguments the script to execute, an optional list of arguments available in the script via arguments , and an optional callback function with the result of script execution as a parameter.","ref":"Wallaby.Browser.html#execute_script/2","title":"Wallaby.Browser.execute_script/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#execute_script/3","title":"Wallaby.Browser.execute_script/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#execute_script/4","title":"Wallaby.Browser.execute_script/4","type":"function"},{"doc":"Executes asynchronous JavaScript, taking as arguments the script to execute, an optional list of arguments available in the script via arguments , and an optional callback function with the result of script execution as a parameter.","ref":"Wallaby.Browser.html#execute_script_async/2","title":"Wallaby.Browser.execute_script_async/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#execute_script_async/3","title":"Wallaby.Browser.execute_script_async/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#execute_script_async/4","title":"Wallaby.Browser.execute_script_async/4","type":"function"},{"doc":"Fills in an element identified by query with value . All inputs previously present in the input field will be overridden. Examples page |&gt; fill_in ( Query . text_field ( &quot;name&quot; ) , with : &quot;Chris&quot; ) |&gt; fill_in ( Query . css ( &quot;#password_field&quot; ) , with : &quot;secret42&quot; ) Note Currently, ChromeDriver only supports BMP Unicode characters. Emojis are SMP characters and will be ignored by ChromeDriver. Using JavaScript is a known workaround for filling in fields with Emojis and other non-BMP characters.","ref":"Wallaby.Browser.html#fill_in/3","title":"Wallaby.Browser.fill_in/3","type":"function"},{"doc":"Finds and returns one or more DOM element(s) on the page based on the given query. The query is scoped by the first argument, which is either the %Session{} or an %Element{} . Example session |&gt; find ( Query . css ( &quot;#login-button&quot; ) ) |&gt; assert_text ( &quot;Login&quot; ) buttons = session |&gt; find ( Query . css ( &quot;.login-button&quot; , count : 2 , text : &quot;Login&quot; ) ) Notes Blocks until it finds the element(s) or the max time is reached. By default only 1 element is expected to match the query. If more elements are present then a count can be specified. Use count: :any to allow any number of elements to be present. By default only elements that would be visible to a real user on the page are returned.","ref":"Wallaby.Browser.html#find/2","title":"Wallaby.Browser.find/2","type":"function"},{"doc":"Same as find/2 , but takes a callback to enact side effects on the found element(s). Example session |&gt; find ( Query . css ( &quot;#login-button&quot; ) , fn button -&gt; assert_text ( button , &quot;Login&quot; ) end ) session |&gt; find ( Query . css ( &quot;.login-button&quot; , count : 2 , text : &quot;Login&quot; ) , fn buttons -&gt; assert 2 == length ( buttons ) end ) Notes Returns the first argument to make the function pipe-able.","ref":"Wallaby.Browser.html#find/3","title":"Wallaby.Browser.find/3","type":"function"},{"doc":"Changes the driver focus to the default (top level) frame.","ref":"Wallaby.Browser.html#focus_default_frame/1","title":"Wallaby.Browser.focus_default_frame/1","type":"function"},{"doc":"Changes the driver focus to the frame found by query.","ref":"Wallaby.Browser.html#focus_frame/2","title":"Wallaby.Browser.focus_frame/2","type":"function"},{"doc":"Changes the driver focus to the parent frame.","ref":"Wallaby.Browser.html#focus_parent_frame/1","title":"Wallaby.Browser.focus_parent_frame/1","type":"function"},{"doc":"Focuses the window identified by the given handle. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;can switch between different tabs&quot; , %{ session : session } do handle = session |&gt; visit ( &quot;/home&quot; ) |&gt; window_handle ( ) path = session # click a link that takes you to a new tab |&gt; click ( Query . link ( &quot;External Page&quot; ) ) |&gt; assert_text ( &quot;Some text&quot; ) |&gt; focus_window ( handle ) |&gt; current_path ( ) assert &quot;/home&quot; == path end","ref":"Wallaby.Browser.html#focus_window/2","title":"Wallaby.Browser.focus_window/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#has_css?/2","title":"Wallaby.Browser.has_css?/2","type":"function"},{"doc":"Searches for CSS on the page.","ref":"Wallaby.Browser.html#has_css?/3","title":"Wallaby.Browser.has_css?/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#has_no_css?/2","title":"Wallaby.Browser.has_no_css?/2","type":"function"},{"doc":"Searches for CSS that should not be on the page","ref":"Wallaby.Browser.html#has_no_css?/3","title":"Wallaby.Browser.has_no_css?/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#has_text?/2","title":"Wallaby.Browser.has_text?/2","type":"function"},{"doc":"Matches the parent's content with the provided text. Returns a boolean that indicates if the text was found. Examples session |&gt; visit ( &quot;/&quot; ) |&gt; has_text? ( &quot;Login&quot; ) Example providing query: session |&gt; visit ( &quot;/&quot; ) |&gt; has_text? ( Query . css ( &quot;.login-button&quot; ) , &quot;Login&quot; )","ref":"Wallaby.Browser.html#has_text?/3","title":"Wallaby.Browser.has_text?/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#has_value?/2","title":"Wallaby.Browser.has_value?/2","type":"function"},{"doc":"Matches the Element's value with the provided value.","ref":"Wallaby.Browser.html#has_value?/3","title":"Wallaby.Browser.has_value?/3","type":"function"},{"doc":"Validates that the query returns a result. This can be used to define other types of matchers.","ref":"Wallaby.Browser.html#has?/2","title":"Wallaby.Browser.has?/2","type":"function"},{"doc":"Hovers over an element.","ref":"Wallaby.Browser.html#hover/2","title":"Wallaby.Browser.hover/2","type":"function"},{"doc":"Maximizes the current window. The window is either an instance of a browser tab or another operating system window. For most browsers, this requires a graphical window manager to be running. Usage feature &quot;maximizes the window to the full size of the display&quot; , %{ session : session } do %{ &quot;width&quot; =&gt; width , &quot;height&quot; =&gt; height } = session |&gt; visit ( &quot;/home&quot; ) |&gt; maximize_window ( ) |&gt; window_size ( ) assert width == 1920 assert height == 1080 end","ref":"Wallaby.Browser.html#maximize_window/1","title":"Wallaby.Browser.maximize_window/1","type":"function"},{"doc":"Moves mouse by an offset relative to current cursor position.","ref":"Wallaby.Browser.html#move_mouse_by/3","title":"Wallaby.Browser.move_mouse_by/3","type":"function"},{"doc":"Sets the position of the current window. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;gets the current display position of the window&quot; , %{ session : session } do %{ &quot;x&quot; =&gt; x , &quot;y&quot; =&gt; y } = session |&gt; visit ( &quot;/home&quot; ) |&gt; move_window ( 500 , 500 ) |&gt; window_position ( ) assert x == 500 assert y == 500 end","ref":"Wallaby.Browser.html#move_window/3","title":"Wallaby.Browser.move_window/3","type":"function"},{"doc":"Retrieves the source of the current page.","ref":"Wallaby.Browser.html#page_source/1","title":"Wallaby.Browser.page_source/1","type":"function"},{"doc":"Gets the title for the current page","ref":"Wallaby.Browser.html#page_title/1","title":"Wallaby.Browser.page_title/1","type":"function"},{"doc":"Checks if query is not present within parent and raises if it is found. Returns the given parent if the query is not found so that it is easily pipeable. Examples session |&gt; visit ( &quot;/&quot; ) |&gt; refute_has ( Query . css ( &quot;.secret-admin-content&quot; ) )","ref":"Wallaby.Browser.html#refute_has/2","title":"Wallaby.Browser.refute_has/2","type":"macro"},{"doc":"Sets the size of the current window. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;sets the size of the window to mobile dimensions&quot; , %{ session : session } do %{ &quot;width&quot; =&gt; width , &quot;height&quot; =&gt; height } = session |&gt; visit ( &quot;/home&quot; ) |&gt; resize_window ( 375 , 667 ) |&gt; window_size ( ) assert width == 375 assert height == 667 end","ref":"Wallaby.Browser.html#resize_window/3","title":"Wallaby.Browser.resize_window/3","type":"function"},{"doc":"Attempts to synchronize with the browser. This is most often used to execute queries repeatedly until it either exceeds the time limit or returns a success. Note It is possible that this function never halts. Whenever we experience a stale reference error we retry the query without checking to see if we've run over our time. In practice we should eventually be able to query the DOM in a stable state. However, if this error does continue to occur it will cause wallaby to loop forever (or until the test is killed by exunit).","ref":"Wallaby.Browser.html#retry/2","title":"Wallaby.Browser.retry/2","type":"function"},{"doc":"Checks if the element has been selected. Alias for checked?(element)","ref":"Wallaby.Browser.html#selected?/2","title":"Wallaby.Browser.selected?/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#send_keys/2","title":"Wallaby.Browser.send_keys/2","type":"function"},{"doc":"Sends a list of key strokes to active element. If strings are included then they are sent as individual keys. Special keys should be provided as a list of atoms, which are automatically converted into the corresponding key codes. For a list of available key codes see Wallaby.Helpers.KeyCodes . Example iex&gt; Wallaby.Browser . send_keys ( session , [ &quot;Example Text&quot; , :enter ] ) iex&gt; Wallaby.Browser . send_keys ( session , [ :enter ] ) iex&gt; Wallaby.Browser . send_keys ( session , [ :shift , :enter ] ) Note Currently, ChromeDriver only supports BMP Unicode characters. Emojis are SMP characters and will be ignored by ChromeDriver. Using JavaScript is a known workaround for filling in fields with Emojis and other non-BMP characters.","ref":"Wallaby.Browser.html#send_keys/3","title":"Wallaby.Browser.send_keys/3","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#set_cookie/4","title":"Wallaby.Browser.set_cookie/4","type":"function"},{"doc":"Sets the value of an element. The allowed type for the value depends on the type of the element. The value may be: a string of characters for a text element :selected for a radio button, checkbox or select list option :unselected for a checkbox","ref":"Wallaby.Browser.html#set_value/3","title":"Wallaby.Browser.set_value/3","type":"function"},{"doc":"Takes a screenshot of the current window. Screenshots are saved to a &quot;screenshots&quot; directory in the same directory the tests are run in. Pass [{:name, &quot;some_name&quot;}] to specify the file name. Defaults to a timestamp. Pass [{:log, true}] to log the location of the screenshot to stdout. Defaults to false.","ref":"Wallaby.Browser.html#take_screenshot/2","title":"Wallaby.Browser.take_screenshot/2","type":"function"},{"doc":"Taps the element.","ref":"Wallaby.Browser.html#tap/2","title":"Wallaby.Browser.tap/2","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#text/1","title":"Wallaby.Browser.text/1","type":"function"},{"doc":"Gets the Element's text value. If the element is not visible, the return value will be &quot;&quot; .","ref":"Wallaby.Browser.html#text/2","title":"Wallaby.Browser.text/2","type":"function"},{"doc":"Touches the screen at the given position.","ref":"Wallaby.Browser.html#touch_down/3","title":"Wallaby.Browser.touch_down/3","type":"function"},{"doc":"Touches and holds the element on its top-left corner plus an optional offset.","ref":"Wallaby.Browser.html#touch_down/4","title":"Wallaby.Browser.touch_down/4","type":"function"},{"doc":"Moves the touch pointer (finger, stylus etc.) on the screen to the point determined by the given coordinates.","ref":"Wallaby.Browser.html#touch_move/3","title":"Wallaby.Browser.touch_move/3","type":"function"},{"doc":"Scroll on the screen from the given element by the given offset using touch events.","ref":"Wallaby.Browser.html#touch_scroll/4","title":"Wallaby.Browser.touch_scroll/4","type":"function"},{"doc":"Stops touching the screen.","ref":"Wallaby.Browser.html#touch_up/1","title":"Wallaby.Browser.touch_up/1","type":"function"},{"doc":"Checks if the element is visible on the page","ref":"Wallaby.Browser.html#visible?/2","title":"Wallaby.Browser.visible?/2","type":"function"},{"doc":"Changes the current page to the provided route. Relative paths are appended to the provided base_url. Absolute paths do not use the base_url.","ref":"Wallaby.Browser.html#visit/2","title":"Wallaby.Browser.visit/2","type":"function"},{"doc":"Gets the window handle of the current window. The window is either an instance of a browser tab or another operating system window. Getting the current window handle makes it easy to return to the window in case you need to switch between them. Usage feature &quot;can open a new tab and switch back to the original tab&quot; , %{ session : session } do handle = session |&gt; visit ( &quot;/home&quot; ) |&gt; window_handle ( ) path = session # click a link that takes you to a new tab |&gt; click ( Query . link ( &quot;External Page&quot; ) ) |&gt; assert_text ( &quot;Some text&quot; ) |&gt; focus_window ( handle ) |&gt; current_path ( ) assert &quot;/home&quot; == path end","ref":"Wallaby.Browser.html#window_handle/1","title":"Wallaby.Browser.window_handle/1","type":"function"},{"doc":"Gets the window handles of all available windows. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;can open new tabs for external links&quot; , %{ session : session } do handles = session |&gt; visit ( &quot;/home&quot; ) |&gt; click ( Query . link ( &quot;External Page&quot; ) ) |&gt; click ( Query . link ( &quot;Another External Page&quot; ) ) |&gt; window_handles ( ) assert 3 == length ( path ) end","ref":"Wallaby.Browser.html#window_handles/1","title":"Wallaby.Browser.window_handles/1","type":"function"},{"doc":"Gets the position of the current window. The window is either an instance of a browser tab or another operating system window. Usage feature &quot;gets the current display position of the window&quot; , %{ session : session } do %{ &quot;x&quot; =&gt; x , &quot;y&quot; =&gt; y } = session |&gt; visit ( &quot;/home&quot; ) |&gt; window_position ( ) assert x == 200 assert y == 200 end","ref":"Wallaby.Browser.html#window_position/1","title":"Wallaby.Browser.window_position/1","type":"function"},{"doc":"Gets the size of the current window. The window is either an instance of a browser tab or another operating system window. This is useful for debugging responsive designs where the layout changes as the window size changes. The default window size is 1280x800. Usage feature &quot;gets the size of the current window&quot; , %{ session : session } do %{ &quot;width&quot; =&gt; width , &quot;height&quot; =&gt; height } = session |&gt; visit ( &quot;/home&quot; ) |&gt; window_size ( ) assert width == 1280 assert height == 800 end","ref":"Wallaby.Browser.html#window_size/1","title":"Wallaby.Browser.window_size/1","type":"function"},{"doc":"","ref":"Wallaby.Browser.html#t:opts/0","title":"Wallaby.Browser.opts/0","type":"type"},{"doc":"","ref":"Wallaby.Browser.html#t:parent/0","title":"Wallaby.Browser.parent/0","type":"type"},{"doc":"","ref":"Wallaby.Browser.html#t:queryable/0","title":"Wallaby.Browser.queryable/0","type":"opaque"},{"doc":"","ref":"Wallaby.Browser.html#t:sync_result/0","title":"Wallaby.Browser.sync_result/0","type":"type"},{"doc":"","ref":"Wallaby.Browser.html#t:t/0","title":"Wallaby.Browser.t/0","type":"type"},{"doc":"","ref":"Wallaby.Browser.html#t:take_screenshot_opt/0","title":"Wallaby.Browser.take_screenshot_opt/0","type":"type"},{"doc":"The Chrome driver uses Chromedriver to power Google Chrome and Chromium. Usage Start a Wallaby Session using this driver with the following command: { :ok , session } = Wallaby . start_session ( ) Configuration Headless Chrome will run in headless mode by default. You can disable this behaviour using the following configuration. This will override the default capabilities and capabilities set with application configuration. This will not override capabilities passed in directly to Wallaby.start_session/1 . config :wallaby , chromedriver : [ headless : false ] Capabilities These capabilities will override the default capabilities. config :wallaby , chromedriver : [ capabilities : %{ # something } ] ChromeDriver binary If ChromeDriver is not available in your path, you can specify it's location. config :wallaby , chromedriver : [ path : &quot;path/to/chrome&quot; ] Chrome binary This configures which instance of Google Chrome to use. This will override the default capabilities and capabilities set with application configuration. This will not override capabilities passed in directly to Wallaby.start_session/1 . config :wallaby , chromedriver : [ binary : &quot;path/to/chrome&quot; ] Default Capabilities By default, Chromdriver will use the following capabilities You can read more about capabilities in the JSON Wire Protocol documentation and the Chromedriver documentation. %{ javascriptEnabled : false , loadImages : false , version : &quot;&quot; , rotatable : false , takesScreenshot : true , cssSelectorsEnabled : true , nativeEvents : false , platform : &quot;ANY&quot; , unhandledPromptBehavior : &quot;accept&quot; , loggingPrefs : %{ browser : &quot;DEBUG&quot; } , chromeOptions : %{ args : [ &quot;--no-sandbox&quot; , &quot;window-size=1280,800&quot; , &quot;--disable-gpu&quot; , &quot;--headless&quot; , &quot;--fullscreen&quot; , &quot;--user-agent=Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36&quot; ] } } Notes This driver requires Chromedriver to be installed in your path.","ref":"Wallaby.Chrome.html","title":"Wallaby.Chrome","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Wallaby.Chrome.html#child_spec/1","title":"Wallaby.Chrome.child_spec/1","type":"function"},{"doc":"Options to pass to Wallaby.start_session/1 Wallaby . start_session ( capabilities : %{ chromeOptions : %{ args : [ &quot;--headless&quot; ] } } , create_session_fn : fn url , capabilities -&gt; WebdriverClient . create_session ( url , capabilities ) end ) :capabilities - capabilities to pass to chromedriver on session startup create_session_fn - Deprecated and to be removed :readiness_timeout - milliseconds to wait for chromedriver server to be ready before raising a timeout error. (Default: 10000)","ref":"Wallaby.Chrome.html#t:start_session_opts/0","title":"Wallaby.Chrome.start_session_opts/0","type":"type"},{"doc":"Sets up the Wallaby DSL in a module. All functions in Wallaby.Browser are now accessible without a module name and Wallaby.Browser , Wallaby.Element and Wallaby.Query are all aliased. Example defmodule MyPage do use Wallaby.DSL @name_field Query . text_field ( &quot;Name&quot; ) @email_field Query . text_field ( &quot;email&quot; ) @save_button Query . button ( &quot;Save&quot; ) def register ( session ) do session |&gt; visit ( &quot;/registration.html&quot; ) |&gt; fill_in ( @name_field , with : &quot;Chris&quot; ) |&gt; fill_in ( @email_field , with : &quot;c@keathly.io&quot; ) |&gt; click ( @save_button ) end end","ref":"Wallaby.DSL.html","title":"Wallaby.DSL","type":"module"},{"doc":"Defines an Element Struct and interactions with Elements. Typically these functions are used in conjunction with a find : page |&gt; find ( Query . css ( &quot;.some-element&quot; ) , fn ( element ) -&gt; Element . click ( element ) end ) These functions can be used to create new actions specific to your application: def create_todo ( todo_field , todo_text ) do todo_field |&gt; Element . click ( ) |&gt; Element . fill_in ( with : todo_text ) |&gt; Element . send_keys ( [ :enter ] ) end Retrying Unlike Browser the actions in Element do not retry if the element becomes stale. Instead an exception will be raised.","ref":"Wallaby.Element.html","title":"Wallaby.Element","type":"module"},{"doc":"Gets the value of the element's attribute.","ref":"Wallaby.Element.html#attr/2","title":"Wallaby.Element.attr/2","type":"function"},{"doc":"Clears any value set in the element.","ref":"Wallaby.Element.html#clear/1","title":"Wallaby.Element.clear/1","type":"function"},{"doc":"Clicks the element.","ref":"Wallaby.Element.html#click/2","title":"Wallaby.Element.click/2","type":"function"},{"doc":"Fills in the element with the specified value.","ref":"Wallaby.Element.html#fill_in/2","title":"Wallaby.Element.fill_in/2","type":"function"},{"doc":"Hovers on the element.","ref":"Wallaby.Element.html#hover/1","title":"Wallaby.Element.hover/1","type":"function"},{"doc":"Returns a tuple {x, y} with the coordinates of the left-top corner of given element.","ref":"Wallaby.Element.html#location/1","title":"Wallaby.Element.location/1","type":"function"},{"doc":"Returns a boolean based on whether or not the element is selected. Note This only really makes sense for options, checkboxes, and radio buttons. Everything else will simply return false because they have no notion of &quot;selected&quot;.","ref":"Wallaby.Element.html#selected?/1","title":"Wallaby.Element.selected?/1","type":"function"},{"doc":"Sends keys to the element.","ref":"Wallaby.Element.html#send_keys/2","title":"Wallaby.Element.send_keys/2","type":"function"},{"doc":"Sets the value of the element.","ref":"Wallaby.Element.html#set_value/2","title":"Wallaby.Element.set_value/2","type":"function"},{"doc":"Returns a tuple {width, height} with the size of the given element.","ref":"Wallaby.Element.html#size/1","title":"Wallaby.Element.size/1","type":"function"},{"doc":"Taps the element.","ref":"Wallaby.Element.html#tap/1","title":"Wallaby.Element.tap/1","type":"function"},{"doc":"Gets the element's text value. If the element is not visible, the return value will be &quot;&quot; .","ref":"Wallaby.Element.html#text/1","title":"Wallaby.Element.text/1","type":"function"},{"doc":"Touches and holds the element on its top-left corner plus an optional offset.","ref":"Wallaby.Element.html#touch_down/3","title":"Wallaby.Element.touch_down/3","type":"function"},{"doc":"Scroll on the screen from the given element by the given offset using touch events.","ref":"Wallaby.Element.html#touch_scroll/3","title":"Wallaby.Element.touch_scroll/3","type":"function"},{"doc":"Returns the Element's value.","ref":"Wallaby.Element.html#value/1","title":"Wallaby.Element.value/1","type":"function"},{"doc":"Returns a boolean based on whether or not the element is visible.","ref":"Wallaby.Element.html#visible?/1","title":"Wallaby.Element.visible?/1","type":"function"},{"doc":"","ref":"Wallaby.Element.html#t:attr/0","title":"Wallaby.Element.attr/0","type":"type"},{"doc":"","ref":"Wallaby.Element.html#t:keys_to_send/0","title":"Wallaby.Element.keys_to_send/0","type":"type"},{"doc":"","ref":"Wallaby.Element.html#t:t/0","title":"Wallaby.Element.t/0","type":"type"},{"doc":"","ref":"Wallaby.Element.html#t:value/0","title":"Wallaby.Element.value/0","type":"type"},{"doc":"Helpers for writing features. You can use or import this module. use Wallaby.Feature Calling this module with use will automatically call use Wallaby.DSL . When called with use and you are using Ecto, please configure your otp_app . config :wallaby , otp_app : :your_app","ref":"Wallaby.Feature.html","title":"Wallaby.Feature","type":"module"},{"doc":"Defines a feature with a message. Adding import Wallaby.Feature to your test module will import the Wallaby.Feature.feature/3 macro. This is a drop in replacement for the ExUnit.Case.test/3 macro that you normally use. Adding use Wallaby.Feature to your test module will act the same as import Wallaby.Feature , as well as configure your Ecto repos properly and pass a Wallaby.Session into the test context. Sessions When called with use , the Wallaby.Feature.feature/3 macro will automatically start a single session using the currently configured capabilities and is passed to the feature via the :session key in the context. feature &quot;test with a single session&quot; , %{ session : session } do # ... end If you would like to start multiple sessions, assign the @sessions attribute to the number of sessions that the feature should start, and they will be pass to the feature via the :sessions key in the context. @sessions 2 feature &quot;test with a two sessions&quot; , %{ sessions : [ session_1 , sessions_2 ] } do # ... end If you need to change the headless mode, binary path, or capabilities sent to the session for a specific feature, you can assign @sessions to a list of keyword lists of the options to be passed to Wallaby.start_session/1 . This will start the number of sessions equal to the size of the list. @sessions [ [ headless : false , binary : &quot;some_path&quot; , capabilities : %{ } ] ] feature &quot;test with different capabilities&quot; , %{ session : session } do # ... end If you don't wish to use Wallaby.Feature in your test module, you can add the following code to configure Ecto and create a session. setup tags do :ok = Ecto.Adapters.SQL.Sandbox . checkout ( YourApp.Repo ) unless tags [ :async ] do Ecto.Adapters.SQL.Sandbox . mode ( YourApp.Repo , { :shared , self ( ) } ) end metadata = Phoenix.Ecto.SQL.Sandbox . metadata_for ( YourApp.Repo , self ( ) ) { :ok , session } = Wallaby . start_session ( metadata : metadata ) { :ok , session : session } end Screenshots If you have configured screenshot_on_failure to be true, any exceptions raised during the feature will trigger a screenshot to be taken.","ref":"Wallaby.Feature.html#feature/3","title":"Wallaby.Feature.feature/3","type":"macro"},{"doc":"Shortcuts for various keys. :null :cancel :help :backspace :tab :clear :return :enter :shift :control :alt :pause :escape :space :pageup :pagedown :end :home :left_arrow :up_arrow :right_arrow :down_arrow :insert :delete :semicolon :equals :num0 :num1 :num2 :num3 :num4 :num5 :num6 :num7 :num8 :num9 :multiply :add :seperator :subtract :decimal :divide :command","ref":"Wallaby.Helpers.KeyCodes.html","title":"Wallaby.Helpers.KeyCodes","type":"module"},{"doc":"","ref":"Wallaby.Helpers.KeyCodes.html#chars/1","title":"Wallaby.Helpers.KeyCodes.chars/1","type":"function"},{"doc":"","ref":"Wallaby.Helpers.KeyCodes.html#json/1","title":"Wallaby.Helpers.KeyCodes.json/1","type":"function"},{"doc":"Provides the query DSL. Queries are used to locate and retrieve DOM elements from a browser (see Wallaby.Browser ). You create queries like so: Query . css ( &quot;.some-css&quot; ) Query . xpath ( &quot;.//input&quot; ) Form elements There are several custom finders for locating form elements. Each of these allows finding by their name, id text, or label text. This allows for more robust querying and decouples the query from presentation selectors like CSS classes. Query . text_field ( &quot;My Name&quot; ) Query . checkbox ( &quot;Checkbox&quot; ) Query . select ( &quot;A Fancy Select Box&quot; ) Query Options All of the query operations accept the following options: :count - The number of elements that should be found or :any (default: 1). If a :minimum or :maximum is specified, it defaults to nil . :minimum - The minimum number of elements that should be found, or nil (default: nil ). :maximum - The maximum number of elements that should be found, or nil (default: nil ). :visible - Determines if the query should return only visible elements (default: true ). :selected - Determines if the query should return only selected elements (default: :any ). :text - Text that should be found inside the element (default: nil ). :at - The position (a number or :all ) of the element to return if multiple elements satisfy the query. (default: :all ) Query options can also be set via functions by the same names: Query . css ( &quot;.names&quot; ) |&gt; Query . visible ( true ) |&gt; Query . count ( 3 ) Re-using queries It is often convenient to re-use queries. The easiest way is to use module attributes: @name_field Query . text_field ( &quot;User Name&quot; ) @submit_button Query . button ( &quot;Save&quot; ) If the queries need to be dynamic then you should create a module that encapsulates the queries as functions: defmodule TodoListPage do def todo_list do Query . css ( &quot;.todo-list&quot; ) end def todos ( count ) do Query . css ( &quot;.todo&quot; , count : count ) end end What does my query do? Wanna check out what exactly your query will do? Look no further than Wallaby.Query.compile/1 - it takes a query and returns the CSS or xpath query that will be sent to the driver: iex&gt; Wallaby.Query . compile Wallaby.Query . text ( &quot;my text&quot; ) { :xpath , &quot;.//*[contains(normalize-space(text()), \\&quot; my text \\&quot; )]&quot; } So, whenever you're not sure whatever a specific query will do just compile it to get all the details!","ref":"Wallaby.Query.html","title":"Wallaby.Query","type":"module"},{"doc":"Updates a query's at option. Example Query . css ( &quot;.names&quot; ) |&gt; Query . at ( 3 )","ref":"Wallaby.Query.html#at/2","title":"Wallaby.Query.at/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#at_number/1","title":"Wallaby.Query.at_number/1","type":"function"},{"doc":"Checks if the provided attribute, value pair is contained anywhere.","ref":"Wallaby.Query.html#attribute/3","title":"Wallaby.Query.attribute/3","type":"function"},{"doc":"Looks for a button (literal button or input type button, submit, image or reset) where the provided selector is the id, name, value, alt or title of the button.","ref":"Wallaby.Query.html#button/2","title":"Wallaby.Query.button/2","type":"function"},{"doc":"Looks for a checkbox where the provided selector is the id, name or placeholder of the checkbox itself or alternatively the id or the text of the label.","ref":"Wallaby.Query.html#checkbox/2","title":"Wallaby.Query.checkbox/2","type":"function"},{"doc":"Compiles a query into CSS or xpath so its ready to be sent to the driver iex&gt; Wallaby.Query . compile Wallaby.Query . text ( &quot;my text&quot; ) { :xpath , &quot;.//*[contains(normalize-space(text()), \\&quot; my text \\&quot; )]&quot; } iex&gt; Wallaby.Query . compile Wallaby.Query . css ( &quot;#some-id&quot; ) { :css , &quot;#some-id&quot; }","ref":"Wallaby.Query.html#compile/1","title":"Wallaby.Query.compile/1","type":"function"},{"doc":"","ref":"Wallaby.Query.html#count/1","title":"Wallaby.Query.count/1","type":"function"},{"doc":"Updates a query's count . The count specifies how many elements you expect to be present within the scope of the query and can be any number greater than zero or :any . Example # Exactly 2 elements Query . css ( &quot;.names &gt; li&quot; ) |&gt; Query . count ( 2 ) # Any number of elements Query . css ( &quot;.names &gt; li&quot; ) |&gt; Query . count ( :any )","ref":"Wallaby.Query.html#count/2","title":"Wallaby.Query.count/2","type":"function"},{"doc":"Literally queries for the CSS selector you provide.","ref":"Wallaby.Query.html#css/2","title":"Wallaby.Query.css/2","type":"function"},{"doc":"Checks if the data attribute is contained anywhere.","ref":"Wallaby.Query.html#data/3","title":"Wallaby.Query.data/3","type":"function"},{"doc":"Looks for a file input where the selector is the id or name of the file input itself or the id or text of the label.","ref":"Wallaby.Query.html#file_field/2","title":"Wallaby.Query.file_field/2","type":"function"},{"doc":"Looks for a text input field where the provided selector is the id, name or placeholder of the text field itself or alternatively the id or the text of the label.","ref":"Wallaby.Query.html#fillable_field/2","title":"Wallaby.Query.fillable_field/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#inner_text/1","title":"Wallaby.Query.inner_text/1","type":"function"},{"doc":"Looks for a link where the selector is the id, link text, title of the link itself or the alt of an image child node.","ref":"Wallaby.Query.html#link/2","title":"Wallaby.Query.link/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#matches_count?/2","title":"Wallaby.Query.matches_count?/2","type":"function"},{"doc":"Looks for an option that contains the given text.","ref":"Wallaby.Query.html#option/2","title":"Wallaby.Query.option/2","type":"function"},{"doc":"Looks for a radio button where the provided selector is the id, name or placeholder of the radio button itself or alternatively the id or the text of the label.","ref":"Wallaby.Query.html#radio_button/2","title":"Wallaby.Query.radio_button/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#result/1","title":"Wallaby.Query.result/1","type":"function"},{"doc":"Looks for a select box where the provided selector is the id or name of the select box itself or alternatively the id or the text of the label.","ref":"Wallaby.Query.html#select/2","title":"Wallaby.Query.select/2","type":"function"},{"doc":"Updates a query's selected option. Examples Query . css ( &quot;#select-dropdown&quot; ) |&gt; Query . selected ( true ) Query . css ( &quot;#select-dropdown&quot; ) |&gt; Query . selected ( false )","ref":"Wallaby.Query.html#selected/2","title":"Wallaby.Query.selected/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#selected?/1","title":"Wallaby.Query.selected?/1","type":"function"},{"doc":"","ref":"Wallaby.Query.html#specific_element_requested/1","title":"Wallaby.Query.specific_element_requested/1","type":"function"},{"doc":"This function can be used in one of two ways. The first is by providing a selector and possible options. This generates a query that checks if the provided text is contained anywhere. Example Query . text ( &quot;Submit&quot; , count : 1 ) The second is by providing an existing query and a value to set as the text option. Example submit_button = Query . css ( &quot;#submit-button&quot; ) update_button = submit_button |&gt; Query . text ( &quot;Update&quot; ) create_button = submit_button |&gt; Query . text ( &quot;Create&quot; )","ref":"Wallaby.Query.html#text/2","title":"Wallaby.Query.text/2","type":"function"},{"doc":"See Wallaby.Query.fillable_field/2 .","ref":"Wallaby.Query.html#text_field/2","title":"Wallaby.Query.text_field/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#validate/1","title":"Wallaby.Query.validate/1","type":"function"},{"doc":"Checks if the provided value is contained anywhere.","ref":"Wallaby.Query.html#value/2","title":"Wallaby.Query.value/2","type":"function"},{"doc":"Updates a query's visibility (visible if true , hidden if false ). Examples Query . css ( &quot;#modal&quot; ) |&gt; Query . visible ( true ) Query . css ( &quot;#modal&quot; ) |&gt; Query . visible ( false )","ref":"Wallaby.Query.html#visible/2","title":"Wallaby.Query.visible/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#visible?/1","title":"Wallaby.Query.visible?/1","type":"function"},{"doc":"Literally queries for the xpath selector you provide.","ref":"Wallaby.Query.html#xpath/2","title":"Wallaby.Query.xpath/2","type":"function"},{"doc":"","ref":"Wallaby.Query.html#t:attribute_key_value_pair/0","title":"Wallaby.Query.attribute_key_value_pair/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:compiled/0","title":"Wallaby.Query.compiled/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:conditions/0","title":"Wallaby.Query.conditions/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:html_validation/0","title":"Wallaby.Query.html_validation/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:method/0","title":"Wallaby.Query.method/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:opts/0","title":"Wallaby.Query.opts/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:result/0","title":"Wallaby.Query.result/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:selector/0","title":"Wallaby.Query.selector/0","type":"type"},{"doc":"","ref":"Wallaby.Query.html#t:t/0","title":"Wallaby.Query.t/0","type":"type"},{"doc":"The Selenium driver uses Selenium Server to power many types of browsers (Chrome, Firefox, Edge, etc). Usage Start a Wallaby Session using this driver with the following command: { :ok , session } = Wallaby . start_session ( ) Configuration Capabilities These capabilities will override the default capabilities. config :wallaby , selenium : [ capabilities : %{ # something } ] Selenium Remote URL It is possible to globally set Selenium's &quot;Remote URL&quot; by setting the following option. By default it is http://localhost:4444/wd/hub/ config :wallaby , selenium : [ remote_url : &quot;http://selenium_url&quot; ] Default Capabilities By default, Selenium will use the following capabilities You can read more about capabilities in the JSON Wire Protocol documentation. %{ javascriptEnabled : true , browserName : &quot;firefox&quot; , &quot;moz:firefoxOptions&quot; : %{ args : [ &quot;-headless&quot; ] } } Notes Requires selenium-server to be running on port 4444. Wallaby does not manage the start/stop of the Selenium server. Requires GeckoDriver to be installed in your path when using Firefox . Firefox is used by default.","ref":"Wallaby.Selenium.html","title":"Wallaby.Selenium","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Wallaby.Selenium.html#child_spec/1","title":"Wallaby.Selenium.child_spec/1","type":"function"},{"doc":"","ref":"Wallaby.Selenium.html#element_location/1","title":"Wallaby.Selenium.element_location/1","type":"function"},{"doc":"","ref":"Wallaby.Selenium.html#element_size/1","title":"Wallaby.Selenium.element_size/1","type":"function"},{"doc":"Simulates typing into an element. When sending keys to an element and keys is identified as a local file, the local file is uploaded to the Selenium server, returning a file path which is then set to the file input we are interacting with. We then call the WebdriverClient.send_keys/2 to set the remote file path as the input's value.","ref":"Wallaby.Selenium.html#send_keys/2","title":"Wallaby.Selenium.send_keys/2","type":"function"},{"doc":"Options to pass to Wallaby.start_session/1 Wallaby . start_session ( remote_url : &quot;http://selenium_url&quot; , capabilities : %{ browserName : &quot;firefox&quot; } )","ref":"Wallaby.Selenium.html#t:start_session_opts/0","title":"Wallaby.Selenium.start_session_opts/0","type":"type"},{"doc":"Struct containing details about the webdriver session.","ref":"Wallaby.Session.html","title":"Wallaby.Session","type":"module"},{"doc":"","ref":"Wallaby.Session.html#t:t/0","title":"Wallaby.Session.t/0","type":"type"},{"doc":"","ref":"Wallaby.BadMetadataError.html","title":"Wallaby.BadMetadataError","type":"exception"},{"doc":"","ref":"Wallaby.CookieError.html","title":"Wallaby.CookieError","type":"exception"},{"doc":"","ref":"Wallaby.DependencyError.html","title":"Wallaby.DependencyError","type":"exception"},{"doc":"","ref":"Wallaby.DependencyError.html#t:t/0","title":"Wallaby.DependencyError.t/0","type":"type"},{"doc":"","ref":"Wallaby.ExpectationNotMetError.html","title":"Wallaby.ExpectationNotMetError","type":"exception"},{"doc":"","ref":"Wallaby.JSError.html","title":"Wallaby.JSError","type":"exception"},{"doc":"","ref":"Wallaby.NoBaseUrlError.html","title":"Wallaby.NoBaseUrlError","type":"exception"},{"doc":"","ref":"Wallaby.QueryError.html","title":"Wallaby.QueryError","type":"exception"},{"doc":"","ref":"Wallaby.StaleReferenceError.html","title":"Wallaby.StaleReferenceError","type":"exception"},{"doc":"Wallaby helps you test your web applications by simulating realistic user interactions. By default it runs each test case concurrently and manages browsers for you. Here's an example test for a simple Todo application: defmodule MyApp.Features.TodoTest do use ExUnit.Case , async : true use Wallaby.Feature import Wallaby.Query , only : [ css : 2 , text_field : 1 , button : 1 ] feature &quot;users can create todos&quot; , %{ session : session } do session |&gt; visit ( &quot;/todos&quot; ) |&gt; fill_in ( text_field ( &quot;New Todo&quot; ) , with : &quot;Write my first Wallaby test&quot; ) |&gt; click ( button ( &quot;Save&quot; ) ) |&gt; assert_has ( css ( &quot;.alert&quot; , text : &quot;You created a todo&quot; ) ) |&gt; assert_has ( css ( &quot;.todo-list &gt; .todo&quot; , text : &quot;Write my first Wallaby test&quot; ) ) end end Because Wallaby manages multiple browsers for you, its possible to test several users interacting with a page simultaneously. defmodule MyApp.Features.MultipleUsersTest do use ExUnit.Case , async : true use Wallaby.Feature import Wallaby.Query , only : [ text_field : 1 , button : 1 , css : 2 ] @page message_path ( Endpoint , :index ) @message_field text_field ( &quot;Share Message&quot; ) @share_button button ( &quot;Share&quot; ) def message ( msg ) , do : css ( &quot;.messages &gt; .message&quot; , text : msg ) @sessions 2 feature &quot;That users can send messages to each other&quot; , %{ sessions : [ user1 , user2 ] } do user1 |&gt; visit ( @page ) |&gt; fill_in ( @message_field , with : &quot;Hello there!&quot; ) |&gt; click ( @share_button ) user2 |&gt; visit ( @page ) |&gt; fill_in ( @message_field , with : &quot;Hello yourself&quot; ) |&gt; click ( @share_button ) user1 |&gt; assert_has ( message ( &quot;Hello yourself&quot; ) ) user2 |&gt; assert_has ( message ( &quot;Hello there!&quot; ) ) end end Read on to see what else Wallaby can do or check out the Official Documentation .","ref":"readme.html","title":"Introduction","type":"extras"},{"doc":"Your company's name and logo could be here!","ref":"readme.html#sponsors","title":"Introduction - Sponsors","type":"extras"},{"doc":"Requirements Wallaby requires Elixir 1.12+ and OTP 22+. Wallaby also requires bash to be installed. Generally bash is widely available, but it does not come pre-installed on Alpine Linux. Installation Add Wallaby to your list of dependencies in mix.exs : def deps do [ { :wallaby , &quot;~&gt; 0.30&quot; , runtime : false , only : :test } ] end Configure the driver. # Chrome config :wallaby , driver : Wallaby.Chrome # default # Selenium config :wallaby , driver : Wallaby.Selenium You'll need to install the actual drivers as well. Chrome chromedriver Selenium selenium geckodriver (for Firefox) or chromedriver (for Chrome) When calling use Wallaby.Feature and using Ecto, please configure your otp_app . config :wallaby , otp_app : :your_app Then ensure that Wallaby is started in your test_helper.exs : { :ok , _ } = Application . ensure_all_started ( :wallaby ) Phoenix If you're testing a Phoenix application with Ecto and a database that supports sandbox mode , you can enable concurrent testing by adding the Phoenix.Ecto.SQL.Sandbox plug to your Endpoint . It's important that this is at the top of endpoint.ex before any other plugs. # lib/your_app_web/endpoint.ex defmodule YourAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :your_app if sandbox = Application . get_env ( :your_app , :sandbox ) do plug Phoenix.Ecto.SQL.Sandbox , sandbox : sandbox end # ... socket ( &quot;/live&quot; , Phoenix.LiveView.Socket , websocket : [ connect_info : [ :user_agent , session : @session_options ] ] ) It's also important to make sure the user_agent is passed in the connect_info in order to allow the database and browser session to be wired up correctly. Then make sure Phoenix is set up to serve endpoints in tests and that the sandbox is enabled: # config/test.exs config :your_app , YourAppWeb.Endpoint , server : true config :your_app , :sandbox , Ecto.Adapters.SQL.Sandbox This enables the database connection to be owned by the process that is running your test, but the connection is shared to the process receiving the HTTP requests from the browser, so that the same data is visible in both processes. If you have other resources that should be shared by both processes (e.g. expectations or stubs if using Mox ), then you can define a custom sandbox module: # config/support/sandbox.ex defmodule YourApp.Sandbox do def allow ( repo , owner_pid , child_pid ) do # Delegate to the Ecto sandbox Ecto.Adapters.SQL.Sandbox . allow ( repo , owner_pid , child_pid ) # Add custom process-sharing configuration Mox . allow ( MyMock , owner_pid , child_pid ) end end And update the test config to use your custom sandbox: # config/test.exs config :your_app , :sandbox , YourApp.Sandbox Finally, in your test_helper.exs you can provide some configuration to Wallaby. At minimum, you need to specify a :base_url , so Wallaby knows how to resolve relative paths. # test/test_helper.exs Application . put_env ( :wallaby , :base_url , YourAppWeb.Endpoint . url ) Assets Assets are not re-compiled when you run mix test . This can lead to confusion if you've made changes in JavaScript or CSS but tests are still failing. There are two common ways to avoid this confusion. esbuild If you're using esbuild you can add esbuild default to the test alias in the mix config file. defp aliases do [ &quot;test&quot; : [ &quot;esbuild default&quot; , &quot;ecto.create --quiet&quot; , &quot;ecto.migrate&quot; , &quot;test&quot; , ] ] end Webpack The first solution is to run webpack --mode development --watch from the assets directory. This will ensure that assets get recompiled after any changes. The second solution is to add a new alias to your mix config that recompiles assets for you: def project do [ app : :my_app , version : &quot;1.0.0&quot; , aliases : aliases ( ) ] end defp aliases , do : [ &quot;test&quot; : [ &quot;assets.compile --quiet&quot; , &quot;ecto.create --quiet&quot; , &quot;ecto.migrate&quot; , &quot;test&quot; , ] , &quot;assets.compile&quot; : &amp; compile_assets / 1 ] defp compile_assets ( _ ) do Mix . shell ( ) . cmd ( &quot;cd assets &amp;&amp; ./node_modules/.bin/webpack --mode development&quot; , quiet : true ) end This method is less error prone but it will cause a delay when starting your test suite. LiveView In order to test Phoenix LiveView (as of version 0.17.7 ) with Wallaby you'll also need to add a function to each mount/3 function in your LiveViews, or use the on_mount live_session lifecycle hook in the router: defmodule MyApp.Hooks.AllowEctoSandbox do import Phoenix.LiveView import Phoenix.Component def on_mount ( :default , _params , _session , socket ) do allow_ecto_sandbox ( socket ) { :cont , socket } end defp allow_ecto_sandbox ( socket ) do %{ assigns : %{ phoenix_ecto_sandbox : metadata } } = assign_new ( socket , :phoenix_ecto_sandbox , fn -&gt; if connected? ( socket ) , do : get_connect_info ( socket , :user_agent ) end ) Phoenix.Ecto.SQL.Sandbox . allow ( metadata , Application . get_env ( :your_app , :sandbox ) ) end end and then including the function usage in the router: live_session :default , on_mount : MyApp.Hooks.AllowEctoSandbox do # ... end Umbrella Apps If you're testing an umbrella application containing a Phoenix application for the web interface ( MyWebApp ) and a separate persistence application ( MyPersistenceApp ) using Ecto 2 or 3 with a database that supports sandbox mode, then you can use the same setup as above, with a few tweaks. # my_web_app/lib/endpoint.ex defmodule MyWebApp.Endpoint do use Phoenix.Endpoint , otp_app : :my_web_app if Application . get_env ( :my_persistence_app , :sql_sandbox ) do plug Phoenix.Ecto.SQL.Sandbox end Make sure MyWebApp is set up to serve endpoints in tests and that the SQL sandbox is enabled: # my_web_app/config/test.exs config :my_web_app , MyWebApp.Endpoint , server : true config :my_persistence_app , :sql_sandbox , true Then in MyWebApp 's test_helper.exs you can provide some configuration to Wallaby. At minimum, you need to specify a :base_url , so Wallaby knows how to resolve relative paths. # my_web_app/test/test_helper.exs Application . put_env ( :wallaby , :base_url , MyWebApp.Endpoint . url ) You will also want to add phoenix_ecto as a dependency to MyWebApp : # my_web_app/mix.exs def deps do [ { :phoenix_ecto , &quot;~&gt; 3.0&quot; , only : :test } ] end Writing tests It's easiest to add Wallaby to your test suite by using the Wallaby.Feature module. defmodule YourApp.UserListTest do use ExUnit.Case , async : true use Wallaby.Feature feature &quot;users have names&quot; , %{ session : session } do session |&gt; visit ( &quot;/users&quot; ) |&gt; find ( Query . css ( &quot;.user&quot; , count : 3 ) ) |&gt; List . first ( ) |&gt; assert_has ( Query . css ( &quot;.user-name&quot; , text : &quot;Chris&quot; ) ) end end","ref":"readme.html#setup","title":"Introduction - Setup","type":"extras"},{"doc":"The full documentation for the DSL is in the official documentation . Queries and Actions Wallaby's API is broken into 2 concepts: Queries and Actions. Queries allow us to declaratively describe the elements that we would like to interact with and Actions allow us to use those queries to interact with the DOM. Lets say that our html looks like this: &lt;ul class=&quot;users&quot;&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Ada&lt;/span&gt; &lt;/li&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Grace&lt;/span&gt; &lt;/li&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Alan&lt;/span&gt; &lt;/li&gt; &lt;/ul&gt; If we wanted to interact with all of the users then we could write a query like so css(&quot;.user&quot;, count: 3) . If we only wanted to interact with a specific user then we could write a query like this css(&quot;.user-name&quot;, count: 1, text: &quot;Ada&quot;) . Now we can use those queries with some actions: session |&gt; find ( css ( &quot;.user&quot; , count : 3 ) ) |&gt; List . first |&gt; assert_has ( css ( &quot;.user-name&quot; , count : 1 , text : &quot;Ada&quot; ) ) There are several queries for common html elements defined in the Query module . All actions accept a query. This makes it easy to use queries we've already defined. Actions will block until the query is either satisfied or the action times out. Blocking reduces race conditions when elements are added or removed dynamically. Navigation We can navigate directly to pages with visit : visit ( session , &quot;/page.html&quot; ) visit ( session , user_path ( Endpoint , :index , 17 ) ) It's also possible to click links directly: click ( session , link ( &quot;Page 1&quot; ) ) Finding We can find a specific element or list of elements with find : @user_form css ( &quot;.user-form&quot; ) @name_field text_field ( &quot;Name&quot; ) @email_field text_field ( &quot;Email&quot; ) @save_button button ( &quot;Save&quot; ) find ( page , @user_form , fn ( form ) -&gt; form |&gt; fill_in ( @name_field , with : &quot;Chris&quot; ) |&gt; fill_in ( @email_field , with : &quot;c@keathley.io&quot; ) |&gt; click ( @save_button ) end ) Passing a callback to find will return the parent which makes it easy to chain find with other actions: page |&gt; find ( css ( &quot;.users&quot; ) , &amp; assert has? ( &amp;1 , css ( &quot;.user&quot; , count : 3 ) ) ) |&gt; click ( link ( &quot;Next Page&quot; ) ) Without the callback find returns the element. This provides a way to scope all future actions within an element. page |&gt; find ( css ( &quot;.user-form&quot; ) ) |&gt; fill_in ( text_field ( &quot;Name&quot; ) , with : &quot;Chris&quot; ) |&gt; fill_in ( text_field ( &quot;Email&quot; ) , with : &quot;c@keathley.io&quot; ) |&gt; click ( button ( &quot;Save&quot; ) ) Interacting with forms There are a few ways to interact with form elements on a page: fill_in ( session , text_field ( &quot;First Name&quot; ) , with : &quot;Chris&quot; ) clear ( session , text_field ( &quot;last_name&quot; ) ) click ( session , option ( &quot;Some option&quot; ) ) click ( session , radio_button ( &quot;My Fancy Radio Button&quot; ) ) click ( session , button ( &quot;Some Button&quot; ) ) If you need to send specific keys to an element, you can do that with send_keys : send_keys ( session , [ &quot;Example&quot; , &quot;Text&quot; , :enter ] ) Assertions Wallaby provides custom assertions to make writing tests easier: assert_has ( session , css ( &quot;.signup-form&quot; ) ) refute_has ( session , css ( &quot;.alert&quot; ) ) has? ( session , css ( &quot;.user-edit-modal&quot; , visible : false ) ) assert_has and refute_has both take a parent element as their first argument. They return that parent, making it easy to chain them together with other actions. session |&gt; assert_has ( css ( &quot;.signup-form&quot; ) ) |&gt; fill_in ( text_field ( &quot;Email&quot; , with : &quot;c@keathley.io&quot; ) ) |&gt; click ( button ( &quot;Sign up&quot; ) ) |&gt; refute_has ( css ( &quot;.error&quot; ) ) |&gt; assert_has ( css ( &quot;.alert&quot; , text : &quot;Welcome!&quot; ) ) Window Size You can set the default window size by passing in the window_size option into Wallaby.start_session\\1 . Wallaby . start_session ( window_size : [ width : 1280 , height : 720 ] ) You can also resize the window and get the current window size during the test. resize_window ( session , 100 , 100 ) window_size ( session ) Screenshots It's possible take screenshots: take_screenshot ( session ) All screenshots are saved to a screenshots directory in the directory that the tests were run in. If you want to customize the screenshot directory you can pass it as a config value: # config/test.exs config :wallaby , screenshot_dir : &quot;/file/path&quot; # test_helper.exs Application . put_env ( :wallaby , :screenshot_dir , &quot;/file/path&quot; ) Automatic screenshots You can automatically take screenshots on an error when using the Wallaby.Feature.feature/3 macro. # config/test.exs config :wallaby , screenshot_on_failure : true # test_helper.exs Application . put_env ( :wallaby , :screenshot_on_failure , true )","ref":"readme.html#api","title":"Introduction - API","type":"extras"},{"doc":"Asynchronous code Testing asynchronous JavaScript code can expose timing issues and race conditions. We might try to interact with an element that hasn't yet appeared on the page. Elements can become stale while we're trying to interact with them. Wallaby helps solve this by blocking. Instead of manually setting timeouts we can use assert_has and some declarative queries to block until the DOM is in a good state. session |&gt; click ( button ( &quot;Some Async Button&quot; ) ) |&gt; assert_has ( css ( &quot;.async-result&quot; ) ) |&gt; click ( button ( &quot;Next Action&quot; ) ) Interacting with dialogs Wallaby provides several ways to interact with JavaScript dialogs such as window.alert , window.confirm and window.prompt . You can use one of the following functions: For window.alert use accept_alert/2 For window.confirm use accept_confirm/2 or dismiss_confirm/2 For window.prompt use accept_prompt/2-3 or dismiss_prompt/2 All of these take a function as last parameter, which must include the necessary interactions to trigger the dialog. For example: alert_message = accept_alert session , fn ( session ) -&gt; click ( session , link ( &quot;Trigger alert&quot; ) ) end To emulate user input for a prompt, accept_prompt takes an optional parameter: prompt_message = accept_prompt session , [ with : &quot;User input&quot; ] , fn ( session ) -&gt; click ( session , link ( &quot;Trigger prompt&quot; ) ) end JavaScript logging and errors Wallaby captures both JavaScript logs and errors. Any uncaught exceptions in JavaScript will be re-thrown in Elixir. This can be disabled by specifying js_errors: false in your Wallaby config. JavaScript logs are written to :stdio by default. This can be changed to any IO device by setting the :js_logger option in your Wallaby config. For instance if you want to write all JavaScript console logs to a file you could do something like this: { :ok , file } = File . open ( &quot;browser_logs.log&quot; , [ :write ] ) Application . put_env ( :wallaby , :js_logger , file ) Logging can be disabled by setting :js_logger to nil .","ref":"readme.html#javascript","title":"Introduction - JavaScript","type":"extras"},{"doc":"Adjusting timeouts Wallaby uses hackney under the hood, so we offer a hook that allows you to control any hackney options you'd like to have sent along on every request. This can be controlled with the :hackney_options setting in config.exs . config :wallaby , hackney_options : [ timeout : :infinity , recv_timeout : :infinity ] # Overriding a value config :wallaby , hackney_options : [ timeout : 5_000 ]","ref":"readme.html#configuration","title":"Introduction - Configuration","type":"extras"},{"doc":"Wallaby is a community project. Pull Requests (PRs) and reporting issues are greatly welcome. To get started and setup the project, make sure you've got Elixir 1.7+ installed and then: Development Dependencies Wallaby requires the following tools. ChromeDriver Google Chrome GeckoDriver Mozilla Firefox selenium-server-standalone # Unit tests $ mix test # Integration tests for all drivers $ mix test.drivers # Integration tests for a specific driver $ WALLABY_DRIVER=chrome mix test $ WALLABY_DRIVER=selenium mix test # All tests $ mix test.all","ref":"readme.html#contributing","title":"Introduction - Contributing","type":"extras"}]